<template>
	<v-form ref="formInstitutionalData" v-model="isValid">
		<v-card>
			<v-card-text>
				<!-- fila para datos de la carrera -->
				<v-row>
					<v-col cols="12" sm="6">
						<v-select
							label="Institución"
							prepend-icon="fas fa-school"
							:items="institutes"
							outlined
							v-model="scholarData.institute"
						/>
					</v-col>
					<v-col cols="12" sm="6">
						<v-select
							label="Carrera"
							prepend-icon="fas fa-school"
							:items="careers"
							no-data-text="Seleccione antes una institución"
							outlined
							v-model="scholarData.career"
						/>
					</v-col>
				</v-row>
				<!-- fila para datos del semestre -->
				<v-row>
					<v-col cols="12" sm="6">
						<v-text-field
							label="Grado escolar actual"
							prepend-icon="fas fa-school"
							:rules="rulesScholarGrade"
							type="number"
							outlined
							v-model="scholarData.semester"
						/>
					</v-col>
					<v-col cols="12" sm="6">
						<v-text-field
							label="Promedio general"
							prepend-icon="fas fa-school"
							type="number"
							:rules="rulesPromedy"
							outlined
							v-model="scholarData.schoolGrade"
						/>
					</v-col>
				</v-row>
			</v-card-text>
			<v-card-actions>
				<v-row justify-sm="start">
					<v-col cols="12" sm="3">
						<v-btn block outlined color="red" @click="back">Regresar</v-btn>
					</v-col>
					<v-col cols="12" sm="3">
						<v-btn
							:disabled="!isValid || !saved"
							:loading="loading"
							block
							outlined
							color="green"
							@click="save"
						>
							Guardar
							<template v-slot:loader>
								<span>Guardando...</span>
							</template>
						</v-btn>
					</v-col>
					<v-col cols="12" sm="3">
						<v-btn :disabled="saved" block outlined color="blue" @click="closeStepper">Terminar</v-btn>
					</v-col>
				</v-row>
			</v-card-actions>
		</v-card>
	</v-form>
</template>

<script>
import EventBus from "../../bus";
import { mapActions } from "vuex";
import gql from "graphql-tag";

export default {
	name: "FormSchoolData",
	data: () => ({
		isValid: true,
		saved: true,
		loading: false,
		scholarData: {
			institute: "",
			career: "",
			semester: "",
			schoolGrade: ""
		},
		institutes: [],
		careers: [],
		rulesScholarGrade: [
			value => !!value || "Campo requerido",
			value => (value >= 1 && value <= 15) || "Grado de 1 a 15"
		],
		rulesPromedy: [
			value => !!value || "Campo requerido",
			value => (value >= 0 && value <= 10) || "Solo base de 0 a 10"
		]
	}),
	watch: {
		"scholarData.institute": function(newVal, oldVal) {
			this.careers = [];
			this.getCareers();
		}
	},
	methods: {
		...mapActions(["saveScholarData"]),
		// obtiene las escuelas
		async getInstitutes() {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query {
							allInstitutes {
								institute
							}
						}
					`
				});
				for (let i of data.allInstitutes) {
					this.institutes.push(i.institute);
				}
			} catch (error) {}
		},
		// obtiene las carreras de la escuela seleccionada
		async getCareers() {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($institute: String!) {
							allCareers(institute: $institute) {
								key
							}
						}
					`,
					variables: {
						institute: this.scholarData.institute
					}
				});
				for (let i of data.allCareers) {
					this.careers.push(i.key);
				}
			} catch (error) {}
		},
		// Llama a la accion que guarda los datos
		save() {
			this.saveScholarData(this.scholarData);
			this.loading = true;
		},
		closeStepper() {
			EventBus.$emit("closeStepper");
		},
		back() {
			EventBus.$emit("backStep");
		}
	},
	created() {
		this.getInstitutes();
	},
	mounted() {
		// Habilita el boton de terminar los forms
		EventBus.$on("scholarDataSaved", () => {
			setTimeout(() => {
				this.loading = false;
				this.saved = false;
			}, 1500);
		});
	}
};
</script>